<style>
  .fltable td{
      vertical-align: top;  
  }
</style>
<template >
  
  <v-data-table
    hide-default-header
    hide-default-footer
   style="padding:30px">

    <template v-slot:top>
      <div>
          <div>
            <v-toolbar style="box-shadow:none !important">
                <v-toolbar-title><b>{{title}}</b></v-toolbar-title>
                <v-spacer></v-spacer> 

                <div style="margin-right:10px">
                  Requester Name <b>| {{storage_fullname}} | {{storage_company_name}}</b>
                  

                  <v-btn depressed rounded color="primary" to="/listRegister" style="margin-left:10px">List Registration</v-btn>&nbsp;
                                  
                </div>

                
            </v-toolbar>
          
            <div style="padding:20px 25px">
                <v-layout row>
                  <v-flex md6>
                      <v-col cols="12" sm="6" md="12" style="display:none">
                        <table width="100%" class="fltable">
                            <tr>
                              <td width="10%"><b>Material Type</b></td>
                              <td>
                                <v-select
                                  :items="type"
                                  label="Choose Type"
                                  append-icon="mdi-card-bulleted-outline"
                                  solo
                                ></v-select>
                              </td>
                            </tr>
                          </table>
                        
                      </v-col>
                  </v-flex>

                  <v-flex md6>
                      <v-col cols="12" sm="6" md="12">
                        
                      </v-col>
                  </v-flex>
                  
                  <v-flex md6>
                      <v-col cols="12" sm="6" md="12">
                      <v-card
                        max-width="100%"
                        class="mx-auto"
                      >
                        <v-toolbar
                          color="primary"
                          dark
                        >
                        
                          <v-toolbar-title>Naming Convention</v-toolbar-title>

                          <v-spacer></v-spacer>
                        </v-toolbar>

                        <v-list subheader>
                          <br>
                          <v-list-item>
                            <v-list-item-content>
                              <v-list-item-title>
                                  <table class="fltable">
                                    <tr>
                                      <td width="10%"><b>Item Name *</b></td>
                                      <td>

                                          <span>
                                              <v-row>
                                                <v-dialog v-model="dialog" transition="fade-transition" max-width="1200px">
                                                  <template v-slot:activator="{ on }">
                                                    <v-text-field
                                                      v-on:click="modalInc()"
                                                      v-model="inc"
                                                      label="Solo"                         
                                                      placeholder="Enter Item Name"
                                                      solo
                                                    ></v-text-field>
                                                  </template>

                                                  <v-card>
                                                    <v-toolbar dark color="primary" fixed>
                                                      
                                                      <v-toolbar-title>INC (Item Name Code)</v-toolbar-title>
                                                      <v-spacer></v-spacer>
                                                      
                                                      <v-btn icon dark @click="dialog = false">
                                                        <v-icon>mdi-close</v-icon>
                                                      </v-btn>
                                                    </v-toolbar>
                                                    <div style="padding:20px 25px">
                                                        <v-layout row>
                                                          <v-flex md12>
                                                              <v-simple-table>
                                                                <template v-slot:default>
                                                                  <thead>
                                                                    <tr>
                                                                      <th colspan="2"></th>
                                                                      <th class="text-right" colspan="2" style="padding:10px">
                                                                          <v-text-field
                                                                            v-model="searchInc"
                                                                            label="Solo"
                                                                            v-on:keyup.enter="getInc()"
                                                                            placeholder="Enter INC Code / INC Name / Colloquial Name"
                                                                            solo
                                                                            append-icon="search"
                                                                          ></v-text-field>
                                                                      </th>
                                                                    </tr>
                                                                    <tr>
                                                                      <th class="text-left">INC</th>
                                                                      <th class="text-left">INC Name</th>
                                                                      <th class="text-left">Short Name</th>
                                                                      <th class="text-left">Colloquial Name</th>
                                                                      <th class="text-center">action</th> 
                                                                    </tr>
                                                                  </thead>
                                                                  <tbody style="height:100px">
                                                                    <tr v-for="item in list_inc" v-bind:key="item.INC_CODE">
                                                                      <td width="15%">{{item.INC_CODE}}</td>
                                                                      <td width="30%">{{item.INC_NAME}}</td>
                                                                      <td width="30%">{{item.SHORT_NAME}}</td>
                                                                      <td width="30%">{{item.COLLOQUIAL_NAME}}</td>
                                                                      <td width="10%" align="center">
                                                                          <v-btn small color="default" rounded v-on:click="selectInc($event,item.INC_CODE,item.SHORT_NAME)">Pilih</v-btn>
                                                                      </td>
                                                                    </tr>
                                                                  </tbody>
                                                                </template>
                                                              </v-simple-table>
                                                          </v-flex>
                                                        </v-layout>   
                                                    </div>
                                                    <v-divider></v-divider>
                                                    <v-card-actions>
                                                      <v-btn color="blue darken-1" text @click="dialog = false">Cancel</v-btn>
                                                    </v-card-actions>
                                                  </v-card>
                                                  
                                                </v-dialog>
                                              </v-row>
                                            </span>
                                      </td>
                                    </tr>
                                    <tr>
                                      <td><b>Attribute *</b></td>
                                      <td>
                                          <template>
                                              <v-row justify="left">
                                                <v-dialog v-model="dialog2" persistent max-width="600px">
                                                  <template v-slot:activator="{ on }">
                                                    <v-btn color="primary" dark v-on:click="modalAttribute()">Fill Attribute</v-btn>
                                                  </template>
                                                  <v-card>
                                                    <v-card-title>
                                                      <span class="headline">Pengisian Informasi Item</span>
                                                    </v-card-title>
                                                    <v-card-text>
                                                      <v-container>
                                                            <table width="100%" class="fltable">
                                                                <tr>
                                                                  <td>Short Name</td>
                                                                  <td>
                                                                    <v-text-field
                                                                      v-on:keyup="setItemDesc"
                                                                      v-model="shortname"
                                                                      label="Solo"
                                                                      disabled                  
                                                                      placeholder="Enter Shortname"
                                                                      solo
                                                                    ></v-text-field>
                                                                  </td>
                                                                </tr>

                                                                <tr>
                                                                  <td>Type</td>
                                                                  <td>
                                                                    <v-text-field
                                                                      label="Solo"
                                                                      v-on:keyup="setItemDesc"
                                                                      v-model="typem"                      
                                                                      placeholder="Enter Type"
                                                                      solo
                                                                    ></v-text-field>
                                                                  </td>
                                                                </tr>

                                                                <tr>
                                                                  <td>Size</td>
                                                                  <td>
                                                                    <v-text-field
                                                                      label="Solo"
                                                                      v-on:keyup="setItemDesc"
                                                                      v-model="size"                    
                                                                      placeholder="Enter Size"
                                                                      solo
                                                                    ></v-text-field>
                                                                  </td>
                                                                </tr>

                                                                <tr>
                                                                  <td>Shape</td>
                                                                  <td>
                                                                    <v-text-field
                                                                      label="Solo"
                                                                      v-on:keyup="setItemDesc"
                                                                      v-model="shape"                    
                                                                      placeholder="Enter Shape"
                                                                      solo
                                                                    ></v-text-field>
                                                                  </td>
                                                                </tr>

                                                                 <tr>
                                                                  <td>Item Description</td>
                                                                  <td>
                                                                    <v-textarea 
                                                                      :value="modalItemDesc"
                                                                      readonly                      
                                                                      placeholder=""
                                                                      solo
                                                                    ></v-textarea>
                                                                  </td>
                                                                </tr>
                                                            </table>
                                                      </v-container>
                                                      <small>*Informasi ini akan dikombinasikan menjadi rangkaian informasi di item Description</small>
                                                    </v-card-text>
                                                    <v-card-actions>
                                                      <v-spacer></v-spacer>
                                                      <v-btn color="blue darken-1" text @click="dialog2 = false">Close</v-btn>
                                                      <v-btn color="blue darken-1" text @click="addDescription()">Done</v-btn>
                                                    </v-card-actions>
                                                  </v-card>
                                                </v-dialog>
                                              </v-row>
                                            </template>
                                      </td>
                                    </tr>
                                    <tr>
                                      <td><b>Item Description *</b></td>
                                      <td>
                                          <template>
                                              <v-row justify="left">
                                                <v-textarea

                                                  readonly
                                                  v-model="description"
                                                  label="Solo"                         
                                                  placeholder="Enter Item Description"
                                                  solo
                                                ></v-textarea>
                                              </v-row>
                                          </template>
                                      </td>
                                    </tr>             


                                    <tr>
                                      <td><b>Additional Information</b></td>
                                      <td>
                                          <template>
                                              <v-row justify="left">
                                                <v-textarea
                                                  v-model="additional_information"
                                                  label="Solo"  
                                                  :disabled="isDisabled"                        
                                                  placeholder="Enter Additional Information"
                                                  solo
                                                ></v-textarea>
                                              </v-row>
                                            </template>
                                      </td>
                                    </tr>


                                    <tr>
                                      <td><b>Colloquial Name</b></td>
                                      <td>
                                          <template>
                                              <v-row justify="left">
                                                <v-text-field
                                                  v-model="collaquial_name"
                                                  label="Solo"                          
                                                  placeholder="Enter Cross Reference Name"
                                                  solo
                                                ></v-text-field>
                                              </v-row>
                                            </template>
                                      </td>
                                    </tr>

                                    <tr>
                                      <td><b>Material Group *</b></td>
                                      <td>
                                        <template>
                                              <v-row justify="left">
                                                <v-select
                                                    v-model="material_group"
                                                    :items="list_material_group"
                                                    label="Choose Material Group"
                                                    solo
                                                  ></v-select>
                                                </v-row>
                                        </template>
                                      </td>
                                    </tr>
                                    <tr>
                                      <td><b>External Group *</b></td>
                                      <td>
                                          <template>
                                              <v-row justify="left">
                                                <v-select
                                                    v-model="external_group"
                                                    :items="list_external_group"
                                                    label="Choose Extended Group"
                                                    solo
                                                  ></v-select>
                                                </v-row>
                                          </template>
                                      </td>
                                    </tr>
                                    
                                  </table>
                              </v-list-item-title>
                            </v-list-item-content>
                          </v-list-item>

                          
                        </v-list>
                      </v-card>
                      </v-col>
                      
                      <br><br>

                     
                  </v-flex>

                  <v-flex md6>
                      <table width="100%"  class="fltable" style="margin-top:20px">
                          

                          <tr>
                            <td><b>Server *</b></td>
                            <td>
                              <v-select
                                  v-model="server_code"
                                  :items="list_server_code"
                                  label="Choose Server"
                                  solo
                                ></v-select>
                            </td>
                          </tr>

                          <tr>
                            <td><b>Company *</b></td>
                            <td>
                              <v-select
                                  v-model="company_id"
                                  :items="list_company"
                                  label="Choose Company"
                                  solo
                                ></v-select>
                            </td>
                          </tr>

                          <tr>
                            <td><b>Plant *</b></td>
                            <td>
                              <v-select
                                  v-model="plant"
                                  :items="list_plant"
                                  label="Choose Plant"
                                  solo
                                ></v-select>
                            </td>
                          </tr>
                          
                          <tr>
                            <td><b>Storage Location</b></td>
                            <td>
                              <v-select
                                  v-model="storage_location"
                                  :items="list_storage_location"
                                  label="Choose Storage Location"
                                  solo
                                ></v-select>
                            </td>
                          </tr>

                          <tr>
                              <td><b>Brand</b></td>
                              <td> 
                                  <v-text-field
                                  v-model="brand"
                                  label="Solo"                                 
                                  placeholder="Enter Brand"
                                  solo
                                  append-icon="mdi-credit-card-settings-outline"
                                ></v-text-field>
                              </td>
                            </tr>

                            <tr>
                              <td width="30%"><b>Part Number*</b></td>
                              <td>
                                <v-text-field 
                                  v-model="part_no"
                                  label="Solo"                                 
                                  placeholder="Enter Part Number"
                                  solo
                                  append-icon="mdi-credit-card-settings-outline"
                                ></v-text-field>
                              </td>
                            </tr>
                            
                            <tr>
                            <td valign="top"><b>UOM *</b></td>
                            <td >
                                <v-select
                                  v-model="base_uom"
                                  :items="list_base_uom"
                                  label="Choose UOM"
                                  solo
                                ></v-select>
                            </td>
                          </tr>


                          <tr>
                            <td><b>Criticallity</b></td>
                            <td>
                              <v-select
                                  v-model="criticallity"
                                  :items="list_criticallity"
                                  label="Choose Criticallity"
                                  solo
                                ></v-select>
                            </td>
                          </tr>

                          <tr>
                            <td><b>Type Stock</b></td>
                            <td>
                              <v-select
                                  item-text="TYPE_STOCK_VAL"
                                  item-value="TYPE_STOCK_ID"
                                  v-model="type_stock"
                                  :items="list_typestock"
                                  label="Choose Type Stock"
                                  v-bind:value="{ id: TYPE_STOCK_ID, text: TYPE_STOCK_VAL }"
                                  solo
                                ></v-select>
                            </td>
                          </tr>

                          <tr>
                              <td><b>Safety Stock</b></td>
                              <td> 
                                  <v-text-field
                                  v-model="safety_stock"
                                  label="Solo"                                 
                                  placeholder="Enter Safety Stock"
                                  solo
                                  append-icon="mdi-credit-card-settings-outline"
                                ></v-text-field>
                              </td>
                            </tr>

                          <tr>
                            <td><b>Average Usage</b></td>
                            <td>
                              <v-text-field
                                v-model="average_usage" 
                                label="Solo"                         
                                placeholder="Enter Average Usage"
                                solo
                              ></v-text-field>
                            </td>
                          </tr>

                          <tr>
                            <td><b>Request By</b></td>
                            <td>
                              <v-text-field
                                style="font-style:"
                                disabled
                                v-model="request_by"
                                readonly
                                solo
                                value="123"
                                append-icon="mdi-credit-card-settings-outline"
                              ></v-text-field>
                            </td>
                          </tr>
                          <tr>
                            <td><b>Request Date</b></td>
                            <td>
                              <v-text-field
                                style="font-style:"
                                disabled
                                v-model="request_date"
                                readonly
                                solo
                                append-icon="mdi-credit-card-settings-outline"
                              ></v-text-field>
                            </td>
                          </tr>

                          <tr>
                            <td colspan="2">
                              <div align="right">
                                  <v-btn depressed large color="success" to="/searchRegister">New Registration</v-btn>&nbsp;
                                  <v-btn depressed large color="primary" v-on:click="addMaterial">Save Item</v-btn>
                              </div>
                            </td>
                          </tr>                        
                      </table>
                  </v-flex>

                  <v-flex md7>
                      <v-col cols="12" sm="6" md="12">
                          
                      </v-col>    
                  </v-flex>

                  <v-flex md5 style="">
                       <v-col cols="12" sm="6" md="12">
                          <div style="display:none">
                            Attachment : <b>1. Material Doc, 2.Material.png</b>
                            <br><br>
                          </div>
                       </v-col>                     
                  </v-flex>

                </v-layout>  

                <v-dialog
                    v-model="error_dialog"
                    max-width="500px"
                  >
                    <v-card>
                      <v-card-title>
                        Warning
                      </v-card-title>
                      <v-card-text>
                          <p v-if="errors.length">
                            <b>Please correct the following error(s) : </b>
                            <ul>
                              <li v-for="error in errors" v-bind:key="error.id">{{ error }}</li>
                            </ul>
                          </p>
                      </v-card-text>
                      <v-card-actions>
                        <v-btn
                          color="primary"
                          text
                          @click="error_dialog = false"
                        >
                          Close
                        </v-btn>
                      </v-card-actions>
                    </v-card>
                  </v-dialog>

            </div>

            <div style="display:none">
                <v-toolbar style="box-shadow:none !important">
                  <v-toolbar-title>5 Items</v-toolbar-title>
                  
                  <v-spacer></v-spacer>
                  <v-btn large icon v-on:click="deletes" style="margin-right:10px">
                    <v-icon>mdi-delete-circle</v-icon>
                  </v-btn>
              </v-toolbar>
            </div>
        </div>
      </div>
    </template>

    <template v-slot:item.action="{ item }">
      <v-icon
        class="mr-2"
        @click="editItem(desserts)"
      >
        mdi-pencil-outline
      </v-icon>

      <v-icon
        
        @click="deletes(desserts)"
      >
        mdi-delete-outline
      </v-icon>
    </template>
    

   

  
  </v-data-table>

  

</template>


<script>
export default {
    methods: {
      setItemDesc(){

          var shortname = "";
          // if(this.shortname){
          //     shortname = this.shortname + ";"
          // }

          var typem = "";
          if(this.typem){
              typem = this.typem + ";"
          }

          var size = "";
          if(this.size){
              size = this.size + ";"
          }

          var shape = "";
          if(this.shape){
              shape = this.shape + ";"
          }

          var val = shortname +" "+ typem + " " + size + " " + shape + " ";
          this.modalItemDesc = val;
      },
      addDescription(){
        this.description = this.modalItemDesc;
        this.dialog2 = false;
      },
      selectInc(event,code,name){
          this.inc_code=code;
          this.inc = name;
          this.shortname = name;
          this.dialog = false;
      },
      getColor (calories) {
          if (calories > 400) return 'red'
          else if (calories > 200) return 'orange'
          else return 'green'
      },
      getBrand(){
          var self = this;
          var url = this.base_url + "dropdown/dropselect/tm_brand/BRAND_NAME"; 
          this.axios.get(url).then(function (response) {
            self.list_brand = response.data;
          })
      },
      getInc(){
          var self = this;
          var val  = self.searchInc; 
          var url  = self.base_url + "search/inc";
          this.axios.post(url , {
              param : val
          })
          .then(function (response) {
              self.list_inc = response.data;
          });
      },
      getServer(){

      },
      getCompany(){

      },
      getPlant(){

      },
      getStorageLocation(){

      },
      getUom(){

      },
      getAttribute(){
          var self = this;
          var inc_code = self.inc_code;
          var url = this.base_url + "dropdown/dropdynamic/tm_inc_attribute/INC_CODE/"+inc_code; 
          this.axios.get(url).then(function (response) {
            self.list_inc_attribute = response.data;
          })
      },
      getMaterialGroup(){

      },
      modalInc(){
        this.dialog = true;
        this.getInc();
      },
      modalAttribute(){
        this.getAttribute();
        this.dialog2 = true;
      },
      addMaterial(){
            var url = this.base_url + 'material/add';
            var self = this;
            
            self.errors = [];
            if(!this.inc) this.errors.push("INC required.");
            if(!this.description) this.errors.push("Description required.");
            if(!this.part_no) this.errors.push("Part Number required.");
            if(!this.base_uom) this.errors.push("Base UOM required.");
            if(!this.company_id) this.errors.push("Company required.");
            if(!this.plant) this.errors.push("Plant required.");

            if(this.errors.length){
                self.error_dialog = true;

            }else{
                var brand_name ="";
                if(this.brand){
                  brand_name = this.list_brand.find(a=>a.BRAND_CODE==this.brand).BRAND_NAME;
                }

                this.axios.post(url , {
                    request_no : "",
                    request_by : "",
                    request_date : "",
                    inc : "",
                    description : "",
                    additional_information : "",
                    collaquial_name : "",
                    brand : brand_name,
                    part_no : "",
                    base_uom : "",
                    material_group : "",
                    external_group : "",
                    company_id : "",
                    company_name : "",
                    plant : "",
                    storage_location : "",
                    average_usage : this.average_usage,
                    safety_stock : "",
                    criticallity : "",
                    material_type : "",
                    valuation_class : "",
                    attachment : "",
                    server_code : "",
                    message : "",
                    item_status : "",
                    cataloguer : ""
                })
                .then(function (response) {

                    self.result = response.data;
                    self.loading = false;
                    self.container = true;
                })
                .catch(function (error) {
                    self.result = error;
                    self.loading = false;
                    self.container = true;
                });
            }     
      },
      getDate(){
        var date = new Date().toLocaleString('en-US',{hour12:false}).split(" ");
        //var time = date[1];
        var mdy = date[0];

        mdy = mdy.split('/');
        var month = parseInt(mdy[0]);
        var day = parseInt(mdy[1]); 
        var year = parseInt(mdy[2]);

        // Putting it all together
        var formattedDate = year + '-' + month + '-' + day; 
        return formattedDate;
      }, 
      getMaterialDetail(){
          var id = this.$route.params.id;
          var self = this; 
          var url = this.base_url + "dropdown/dropdynamic/tm_initial_item/MATERIAL_NUMBER/" + id; 
          this.axios.get(url).then(function (response) {
              self.data_material = response.data;
              self.inc = self.data_material[0].INC_NAME;
              self.description = self.data_material[0].DESCRIPTION;
              self.additional_information = self.data_material[0].ADDITIONAL_INFORMATION;
              self.collaquial_name = self.data_material[0].collaquial_name;
              self.brand = self.data_material[0].BRAND;
              self.part_no = self.data_material[0].PART_NO;
              self.base_uom = self.data_material[0].BASE_UOM;
              self.material_group = self.data_material[0].MATERIAL_GROUP; 
              self.external_group = self.data_material[0].external_group;
              self.company_id = self.data_material[0].COMPANY_ID;
              self.company_name = self.data_material[0].COMPANY_NAME;
              self.plant = self.data_material[0].PLANT;
              self.storage_location = self.data_material[0].STORAGE_LOCATION;
              self.average_usage = self.data_material[0].AVERAGE_USER;
              self.safety_stock = self.data_material[0].SAFETY_STOK;
              self.criticallity = self.data_material[0].criticallity;
              self.material_type = self.data_material[0].MATERIAL_TYPE;
              self.valuation_class = self.data_material[0].VALUATION_CLASS;
              self.server_code = self.data_material[0].SERVER_CODE;
          })
      }
    },
    mounted(){ 
        this.getBrand();
        this.getInc();
        this.request_date = this.getDate();
        this.request_by = this.storage_username;
        this.additional_information.disabled;
        
        //if(this.$route.params.id){
        this.getMaterialDetail();
        //}
    },
    data () { 
      return {
        shortname: "",
        design : "",
        typem : "",
        size: "",
        shape:"",
        color:"",
        inc_code:"",
        name : "Registration",
        title : "Form Item Material Registration",
        dialog: false,
        dialog2: false,
        modalItemDesc:"",
        select: { BRAND_CODE: '1', BRAND_NAME: 'Catterpilar' },
        errors:[],
        uom:[],
        type: [],
        error_dialog:false,
        date:"",
        isDisabled:false,

        //searchparam................................
        searchInc:"",

        //storage.....................................
        storage_username : localStorage.getItem("username"),
        storage_fullname : localStorage.getItem("fullname"),
        storage_company_id : localStorage.getItem("company_id"),
        storage_company_name : localStorage.getItem("company_name"),
        storage_role : localStorage.getItem("fullname"),

        //v-list.......................................
        list_inc : "",
        list_brand : "",
        list_base_uom : ['cm','mm','each','bottle'],
        list_material_group : ['1200 FIRE CONTROL EQUIPME','1300 AMMUNITION AND EXPLO','1900 SHIPS, SMALL CRAFT','2000 SHIP AND MARINE EQUI'],
        list_external_group : ['1230','1250','1290','1376','1910','1915','1930','1940','1945','1955','1990','2010','2020','2030'],
        list_company : ['PT. KUANSING INTI MAKMUR','PT. TRISULA KENCANA SAKTI','PT. BARA HARMONIS BATANG'],
        list_plant : ['O203','O201','2401','2402'],
        list_storage_location : ['StorLoc 1','StorLoc 2','StorLoc 3'],
        list_safety_stock : "",
        list_inc_attribute : "",
        list_criticallity : ['High','Medium','Low'],
        list_material_type : "",
        list_valuation_class : "",
        list_server_code : ['GEMS','BKES','Berau Coal'],
        list_item_status : "",
        list_cataloguer : "",
        list_typestock : [{"TYPE_STOCK_ID":"Y","TYPE_STOCK_VAL":"Stock"},{"TYPE_STOCK_ID":"N","TYPE_STOCK_VAL":"Non Stock"}],
        data_material:"",

        //v-model.......................................
        request_no : "",
        request_by : "",
        request_date : "",
        inc : "",
        description : "",
        additional_information : "",
        collaquial_name : "",
        brand : "",
        part_no : "",
        base_uom : "",
        material_group : "", 
        external_group : "",
        company_id : "",
        company_name : "",
        plant : "",
        storage_location : "",
        average_usage : "",
        safety_stock : "",
        criticallity : "",
        material_type : "",
        valuation_class : "",
        attachment : "",
        server_code : "",
        message : "",
        item_status : "",
        cataloguer : ""
        
      }
    },
  }
</script>
